module nscrdll;

private import std.c.windows.windows;
private import std.windows.charset;
private import std.string;

private import nscr.result;
private import nscr.plugin;

private import fileutil.file;
private import fileutil.meddle;

private int major = 0;
private int minor = 2;

extern(C)
{
	export BOOL NScrPlugInMain(HINSTANCE hinstance, HWND hwnd, char *param, int *ret_int, char *ret_str)
	{
		char[] paramstr = fromMBSz(param);
		char[] command = getCommand(paramstr);
		char[][] args = getArgs(paramstr);
		attach(ret_int, ret_str);
		
		try{
			switch(command){
			case "mkdir":
				setret(invoke(&mkdir, args));
				break;

			case "rmdir":
				setret(invoke(&rmdir, args));
				break;

			case "curdir":
				setret(invoke(&curdir, args));
				break;

			case "fileread":
				setret(invoke(&fileread, args));
				break;

			case "filewrite":
				setret(invoke(&filewrite, args));
				break;

			case "fileappend":
				setret(invoke(&fileappend, args));
				break;

			case "fileappendln":
				setret(invoke(&fileappendln, args));
				break;

			case "filerename":
				setret(invoke(&filerename, args));
				break;

			case "filesize":
				setret(invoke(&filesize, args));
				break;

			case "filecopy":
				setret(invoke(&filecopy, args));
				break;

			case "filelist":
				setret(invoke(&filelist, args));
				break;

			case "dirlist":
				setret(invoke(&dirlist, args));
				break;

			case "version":
			    setret(Result(major * 10 + minor, join([toString(major), toString(minor)], ".")));
				break;

			default:
				setret(false, paramstr);
				break;
			}
		}
		catch(Exception e){
			setret(false, e.toString());
		}
		return false;
	}
}
