module fileutil.meddle;

private import std.file;
private import std.path;


/// meddlesome invoker
R invoke(R, T...)(R function(T) func, char[][] args){
	T tuple;
	foreach(i, t; tuple){
		if(i >= args.length) break;
		tuple[i] = meddle!(typeof(tuple[i]))(args[i]);
	}
	return func(tuple);
}


/// meddlesome invoker
R invoke(Dummy=void, R, T...)(R delegate(T) func, char[][] args){
	T tuple;
	foreach(i, t; tuple){
		if(i >= args.length) break;
		tuple[i] = meddle!(typeof(tuple[i]))(args[i]);
	}
	return func(tuple);
}


/// general meddling
R meddle(R)(R arg){
	return arg;
}


/// str to int meddling
R meddle(R : int)(char[] arg){
	return std.conv.toInt(arg);
}


/// str to str[] meddling
R meddle(R : char[][])(char[] arg){
	return std.string.split(arg);
}


typedef char[] filepath;
/// str to filepath meddling
R meddle(R : filepath)(char[] arg){
	if(!std.path.isabs(arg)){
		arg = std.path.join(std.file.getcwd(), arg);
	}
	return cast(filepath)arg;
}


typedef char[] dirpath;
/// str to dirpath meddling
R meddle(R : dirpath)(char[] arg){
	arg = std.string.replace(arg, "/", "\\");
	if(arg == std.path.curdir){
		return cast(dirpath)std.file.getcwd();
	}
	if(!std.path.isabs(arg)){
		arg = std.path.join(std.file.getcwd(), arg);
	}
	if(std.file.exists(arg) && std.file.isfile(arg)){
		// ファイル名の場合はディレクトリ名を抜き出す。
		arg = std.path.getDirName(arg);
	}
	return cast(dirpath)arg;
}


private import nscr.charset;

typedef char[] nscrtext;
/// str to nscrtext meddling
R meddle(R : nscrtext)(char[] arg){
	return cast(nscrtext)toNScrCharset(arg);
}


unittest
{
	char[] strcat2(char[] str1, char[] str2, char[] str3){
		return str1 ~ str2 ~ str3;
	}
	void main(){
		assert(invoke(&strcat2, ["strcat2", " is ", "OK!"]) == "strcat2 is OK!", "strcat2 is NG...");
	}
}
