module nscr.result;

private import std.string;
private import std.windows.charset;

int* retint = null;     ///< 返す数値のポインタ
char* retstr = null;    ///< 返す文字列のポインタ

/// 返すポインタを結合する。
/*
	@param[in]	intptr	返す数値のポインタ
	@param[in]	strptr	返す文字列のポインタ
*/
void attach(int *intptr, char* strptr){
	retint = intptr;
	retstr = strptr;
}

/// 返すポインタを分離する。
void detach(){
	retint = null;
	retstr = null;
}

/// NScripter向けに戻り値を設定する。
/*
	@param[in]	intval	返す数値
	@param[in]	strval	返す文字列（UTF-8）
*/
void setret(int intval, char[] strval){
	*retint = intval;
	char[] str = std.string.toString(toMBSz(strval));
	int len = str.length;
	retstr[0..len] = str[0..len];
	retstr[len] = '\0';
}

/// 返却用の構造体
struct Result{
	int intval;    ///< 返す数値
	char[] strval; ///< 返す文字列
	/// 両方まとめて設定
	void set(int intval, char[] strval){
		this.intval = intval;
		this.strval = strval;
	}
}

/// NScripter向けに戻り値を設定する。
/*
	@param[in]	retval	返す数値と文字列
*/
void setret(ref Result retval){
	setret(retval.intval, retval.strval);
}

/// NScripter向けに戻り値を設定する。
/*
	@param[in]	intval	返す数値
*/
void setret(int intval){
	setret(intval, "");
}

/// NScripter向けに戻り値を設定する。
/*
	@param[in]	strval	返す文字列（UTF-8）
*/
void setret(char[] strval){
	setret(true, strval);
}

/// NScripter向けに戻り値を設定する。
/*
	@param[in]	boolval	返す数値
*/
void setret(bool boolval){
	setret(cast(int)boolval, "");
}

